C Program  caustic.f
C Author: J. Pujol
C Example of the formation of a caustic
	dimension xp(400),yp(400),xe(100),ye(100)
         call dashdc('$''''''$',2,5)

	pi=4*atan(1.)
	rad=pi/180
	igo=0

	call opngks
	YB=-2.5
	YT=9
	xl=-1.5
	xr=10
	WT=.7
	WB=.2	
	WL=.0
	WR=.5
cccccccccc	CALL PLCHHQ(.5,.1,'Fig. 8-8',10.,0.,0.)
	CALL PLCHHQ(.5,.965,'Output of caustic.f',10.,0,0.) 
	CALL SET(WL,WR,WB,WT,XL,XR,YB,YT,1)  

	ISYMBSIZ=100
	CALL SETUSV('MS',ISYMBSIZ)

	CALL PCSETI('CD',1)    !DUPLEX CHARACTER SET
	call lwidth(2000)
	call line(-.2,-1.,-.2,5.)
	CALL PLCHHQ(-.2,5.,':1213:',20.,0.,0.)	
	CALL PLCHHQ(-.5,2.,'distance',10.,90.,0.)	

C Plot wavefront 
10	call lwidth(2000)
	if(igo.eq.2)go to 999
	igo=igo+1
	np=361
	do i=1,np
	xp(i)=rad*(i+89)
        yp(i)=.8*sin(xp(i)) !wavefront
	end do
        CALL CURVE(xp,yp,np)     !wavefront W1

	call lwidth(1000)

C Put labels
	xx=.5*(xr+xl)
        CALL PLCHHQ(xp(1)-.1,yp(1),'W:B:1',15.,0.,1.)   !W1
	if(igo.eq.1)then
        CALL PLCHHQ(xp(1)-.1,yp(1),'W:B:1',15.,0.,1.)   !W1 
c        CALL PLCHHQ(xx+.4,-1.5,'(a)',10.,0.,0.) 
	CALL PLCHHQ(5.7,2.,'C',15.,0.,0.)	
	i1=1
	i2=36
	else
c        CALL PLCHHQ(xx+.4,-1.5,'(b)',10.,0.,0.) 
        CALL PLCHHQ(8.2,2.05,'C',15.,0.,-1.)            !C
        CALL PLCHHQ(1.3,2.05,'C:743:',15.,0.,1.)        !C'
	call lined(1.3,2.,4.,2.)
	call lined(5.4,2.,8.1,2.)
	CALL PLCHHQ(8.1,2.,':1213:',20.,-90.,0.)	
	CALL PLCHHQ(1.3,2.,':1213:',20.,90.,0.)	
	i1=1
	i2=72
	end if

C Plot rays (perpendicular to wavefront)
	j=0
	do i=i1,i2
	x=rad*(5*i+89)
        slope=-1./(.8*cos(x)) !slope of ray
	y=.8*sin(x)
	b=y-slope*x

C  Limit the length of the ray. 
	alen=5
	rr=alen**2
	aa=1+slope**2
	bb=2*(slope*(b-y)-x)
	cc=x**2+b**2-2*y*b+y**2-rr
	if(x.le.3*pi/2)then
	x1=(-bb+sqrt(bb**2-4*aa*cc))/(2*aa)
	else
	x1=(-bb-sqrt(bb**2-4*aa*cc))/(2*aa)
	end if
	y1=slope*x1+b
	call line(x,y,x1,y1)
	j=j+1
	xe(j)=x1
	ye(j)=y1
	end do

	call lwidth(1000)
	if(igo.eq.2)then
	call PLCHHQ(4.2,6.1,'O',10.,0.,0)	
	call PLCHHQ(4.,6.,':1245:',8.,0.,0)	
	end if
        CALL PLCHHQ(xe(1)-.1,ye(1),'W:B:2',15.,0.,1.)   !W2
	call lwidth(2000)
        call curve(xe,ye,j)     !wavefront W2

	WL=.5
	WR=1
	CALL SET(WL,WR,WB,WT,XL,XR,YB,YT,1)  
	go to 10

999	call frame
	call clsgks
	stop
	end 

	subroutine ploarrow(dang1,dang2,x2,y2,cchar,ang,size)
	character cchar*6
	dang=dang1
	if(ang.lt.0)dang=dang2
	CALL PLCHHQ(x2,y2,':1213:',size,ANG+dang,0.)
	return
	end

	subroutine lwidth(LINEWIDTH)
	CALL SETUSV('LW',LINEWIDTH)
	return
	end

	subroutine norm(t1,t2,t3)
	absv=sqrt(t1*t1+t2*t2+t3*t3)
	t1=.2*t1/absv
	t2=.2*t2/absv
	t3=.2*t3/absv
	return
	end


