C Program  disper-sta-phase.f
C Author: J. Pujol	
C Illustration of the principle of stationary phase

	dimension x(2000),y(2000),xx(2000),yy(2000),y2(2000),y4(2000)
	character*2 cnum2,cnum*1

	n=2000	 
	step=.001	 
	n2=n/2

	expo=-1.e-6
	w=100
	expo=-1.e-7
	expo=-1.e-1
	w=500

	do i=1,n
	x(i)=(i-n2)*step
	end do

	do i=1,n
	y(i)=exp(expo*x(i)**2) !This is f1(x) in Fig. 7.8
	end do

	do i=1,n
	y2(i)=cos(w*y(i))      !This is f2(x) in Fig. 7.8
	end do
C Find first positive zero crossing
	do i=n2,n-1
	if(y2(i).lt.0.and.y2(i+1).gt.0)then
	xz=x(i)
	go to 5
	end if
	end do
	
C Integral from 0 to i:		!see (7.6.27)
5	y4(1)=y2(1)*step
		do i=2,n
	y4(i)=y4(i-1)+y2(i)*step
		end do
	y4(1)=y4(2)

	ymax=0
	do i=1,n
	absm=abs(y4(i))
	if(absm.gt.ymax)ymax=absm
	end do

c	print*,ymax
	fac=1./ymax
	do i=1,n
	y4(i)=fac*y4(i)
	end do

        CALL OPNGKS        
	CALL PLCHHQ(.5,.965,'Output of disper-sta-phase.f',10.,0,0.)
	CALL PCSETI('CD',1)    
	YB=-1.25
	YT=1.1
	xl=x(1)-.05
	xr=x(n)+.05
	WT=.7
	WB=.1
	WL=.1
	WR=.6
	CALL SET(WL,WR,WB,WT,XL,XR,YB,YT,1)  
	CALL SETUSV('MS',ISYMBSIZ)
	CALL PCSETI('CD',1)    !DUPLEX CHARACTER SET
	CALL LINE(X(1),0,X(n),0)

c	in=inint(x(1))	!nearest integer. This didn't work under Linux. Use the if
	if(x(1).gt.0)then
	in=x(1)+.01
	else
	in=-(-x(1)+.01)
	end if

c	print*,x(1),in
	write(cnum2,10)in
10	format(i2)
	CALL plchhq(x(1),.05,cnum2,10.,0,0.)
	call line(x(1),0,x(1),.02)
	in=x(n)
	write(cnum,20)in
20	format(i1)
	call line(x(n),0,x(n),.02)
	CALL plchhq(x(n),.05,cnum,10.,0,0.)
	x2=(.5*(x(1)+x(n)))
c	in=inint(x2)
	in=x2
c	print*,x2,in
	call line(x2,0,x2,.02)
	write(cnum,20)in
	CALL plchhq(x2,.05,cnum,10.,0,0.)

c	CALL plchhq(x2,-1.2,'Fig. 7-8',10.,0,0.)
	CALL plchhq(.05,-.4,'I(x)',10.,-70.,0.)
	CALL plchhq(x2,1.07,'f (x)',10.,0,0.)
	CALL plchhq(x2,1.04,'1   ',7.,0,0.)
	CALL plchhq(.17,.45,'f (x)',10.,85.,0.)
	CALL plchhq(.2,.45,'2   ',7.,85.,0.)

	call line(-xz,-.04,xz,-0.04)
	CALL plchhq(x2,-0.08,':0235::1104:',12.,0,0.)	!delta
	CALL plchhq(-xz,-.04,':0343:',10.,0,0.)	!arrow
	CALL plchhq(xz,-.04,':0344:',10.,0,0.)	!arrow
	
	m=100
	m2=m/2
	nn=n-m
	do i=1,nn
	xx(i)=x(i+m2)
	yy(i)=y(i+m2)
	end do
	CALL CURVE(xx,yy,nn)
	do i=1,nn
	yy(i)=y2(i+m2)
	end do
	CALL CURVE(xx,yy,nn)
	CALL SETUSV('LW',4000)
	do i=1,nn
	yy(i)=y4(i+m2)
	end do
	CALL CURVE(xx,yy,nn)
	call frame
	call clsgks
	stop
	end 
