C Program disper-string.f 
C Author: J. Pujol	
C Dispersive string [see (7.6.51)]. Fix x and vary t.

	dimension t(1000),y(1000),per(6),t1(6),y1(6),t2(6),y2(6),t3(5),y3(5)
	dimension x2(5),t4(5),y4(5),ttmp(1000),ytmp(1000),x3(5),t5(5),y5(5)
     1,xt(6)
	data per /8.,10.,11.,11.9,12.,12.1/
	data xt /34.1,43.3,53.5,80.5,87,95.8/
	character*8 char
	ipat=ishift(30840,1)
	call dashdb(ipat)
	pi=4*atan(1.)
	rad=pi/180

	ychar=1.15

	a=.5
	pi4=atan(1.)
	pi=4*pi4
	fac=4*pi**2
	aa=a*a
	delx=20
	v=5
	vv=v*v
	av=a/v
	x0=100
	n=500
	t0=100/v
	do i=1,n
	t(i)=t0+.25*(i-1)
	y(i)=0
	end do
	print*,' t(1);',t(1)

        CALL OPNGKS        
	CALL PLCHHQ(.5,.965,'Output of disper-string.f ',10.,0,0.) 
	YB=-.1
	YT=2
	xl=t(1)
	xr=t(n)
	ddelx=xr-xl
	dely=yt-yb

	WT=1
	WB=.1
	WL=0
	WR=1
c	 CALL plchhq(.5,.01,'Fig. 7-9',10.,0,0.)

	CALL SET(WL,WR,WB,WT,XL,XR,YB,YT,1)  

	CALL SETUSV('MS',ISYMBSIZ)
	CALL PCSETI('CD',1)    !DUPLEX CHARACTER SET
        CALL PLCHHQ(20.5,1.1,':0736:',15.,0.,0)        !down arrow
        CALL PLCHHQ(22.,1.1,'x',10.,0.,0)
        CALL PLCHHQ(xr-1,1.7,':0733:',15.,0.,0)  !right arrow

	CALL PCSETI('CD',0)    !COMPLEX CHARACTER SET
        CALL PLCHHQ(xr-1,1.73,'t',10.,0.,0)
	CALL PCSETI('CD',1)    !DUPLEX CHARACTER SET
	call line (110.,1.68,120.,1.68)
        CALL plchhq(110.3,1.68,':0343:',10.,0,0.) !arrow
        CALL plchhq(119.7,1.68,':0344:',10.,0,0.)  !arrow
        CALL plchhq(115.,1.65,'10',10.,0,0.) !arrow

			do j=1,5
	cc=1.9-(2*j-1)*.2
	x=x0+(j-1)*delx
	xx=x*x
c Time for the fifth peak
	co=10*pi-pi4
	tc=sqrt(((co*v/a)**2+xx)/vv)
	t3(j)=tc
	y3(j)=cc
	x2(j)=x

c Time for the seventh peak
	co=14*pi-pi4
	tc=sqrt(((co*v/a)**2+xx)/vv)
	t5(j)=tc
c	y5(j)=cc
c	x3(j)=x
	
	do i=1,n
	tx=vv*t(i)**2-xx
	if(tx.le.0)then
	ic=i
	y(i)=cc
	go to 10
	end if
	y(i)=cc+5*t(i)*tx**(-.75)*cos(pi4+av*sqrt(tx))	!Factor left out!
	if(y(i)-cc.gt.0.2)then
	y(i)=cc+.2
	elseif(y(i)-cc.lt.-0.2)then
	y(i)=cc-.2
	end if
10	end do
	
	t4(j)=t(ic)	!Arrival time of wavefront
	y4(j)=cc

	nn=0
	do i=ic+1,n
	nn=nn+1
	ttmp(nn)=t(i)
	ytmp(nn)=y(i)
	end do

	do i=1,t(n)/10+1
	tt=(i-1)*10
	call line(tt,cc,tt,cc-.035)
	end do

	do i=1,t(n)/5+1
	tt=(i-1)*5
	call line(tt,cc,tt,cc-.02)
	end do

	do i=1,t(n)
	tt=(i-1)
	call line(tt,cc,tt,cc-.01)
	end do
	call line(t(1),cc,t(n),cc)
	CALL CURVE(ttmp,ytmp,nn)
C Find time for given period P:
		do k=1,6
	p=per(k)
	tper=sqrt(fac*xx/(fac*vv-(p**2)*vv*aa))
	if(j.eq.1)then
	t1(k)=tper
	y1(k)=cc
	elseif(j.eq.5)then
	t2(k)=tper
	y2(k)=cc
	end if
		end do
			end do
	char(1:4)='T = '
	do i=1,6
	call line(t1(i),y1(i),t2(i),y2(i))
	ang=atan2((y2(i)-y1(i))/dely,(t2(i)-t1(i))/ddelx)/rad
	print*,ang
	write(char(5:8),11)per(i)
11	format(f4.1)
	 CALL plchhq(xt(i),ychar,char,9.,ang,0.)
	end do

	call setusv('LW',3000)
	call lined(t4(1),y4(1),t4(5),y4(5))

	do i=1,4
	print*,x2(i+1)-x2(i),t3(i+1),t3(i)
	print*,(x2(i+1)-x2(i))/(t3(i+1)-t3(i))
	call line(t3(i+1),y3(i+1),t3(i),y3(i))
	end do

C Plot circles at the fifth peaks
	do j=1,5
	cc=1.9-(2*j-1)*.2
	x=x0+(j-1)*delx
	xx=x*x
	tx=vv*t3(j)**2-xx
	yy=cc+5*t3(j)*tx**(-.75)*cos(pi4+av*sqrt(tx))
	call plchhq(t3(j),yy,'o',9.,0,0)
	end do

C Plot circles at the seventh peaks
	do j=1,5
	cc=1.9-(2*j-1)*.2
	x=x0+(j-1)*delx
	xx=x*x
	tx=vv*t5(j)**2-xx
	yy=cc+5*t5(j)*tx**(-.75)*cos(pi4+av*sqrt(tx))
	call plchhq(t5(j),yy,'+',10.,0,0)
	end do

	call frame
	call clsgks
	stop
	end 
