C Program helix.f
C Author: J. Pujol
C Plot of the circular helixes
C 	x=.5*cos(th); y=.5*sin(th); z=.1*th
C and 
C      x=.5*sin(th); y=-.5*cos(th); z=.1*th
C and the corresponding t, n, and b unit vectors (n is shown in color).

        dimension ias(13)
	dimension xp(300),yp(300),scra(20),iscra(20),char(2)
	common /proj/sinth,costh,sinph,cosph
        data ias /13*1/
	character*3 char
	char(1)='(a)'
	char(2)='(b)'
	
	pi=4*atan(1.)
	rad=pi/180
        call dashdc('$''''''$',2,5)

	icolor=3
	igo=0
	idel=24
	ii1=3

C theta and phi define the viewpoint for the projection subroutine pro(...)
		theta=50*rad
	sinth=sin(theta)
	costh=cos(theta)
		phi=30*rad
	sinph=sin(phi)
	cosph=cos(phi)

        CALL OPNGKS 
	CALL PLCHHQ(.5,.965,'Output of helix.f',10.,0,0.)        
        call gsasf(ias)
        call gsfais(1)
        call dfclrs
        call sfseti('TYPE OF FILL',0)
        call gsplci(0)  

	YB=-.8
	YT=1.5
	xl=-.9
	xr=1.1

	OFFX=0
	OFFY=0

	XLL=XL-OFFX
	XRR=XR+OFFX
	YBB=YB+OFFY
	YTT=YT-OFFY/2
	
	WT=.6
	WB=.2	
	WL=.1
	WR=.5

c	CALL PLCHHQ(.5,.15,'Fig. 8-3',10.,0.,0.)	

	ifac=1
	iii=0
1	if(iii.eq.2)go to 999
	iii=iii+1
	ISYMBSIZ=100
	CALL SETUSV('MS',ISYMBSIZ)

	CALL PCSETI('CD',1)    !DUPLEX CHARACTER SET

	CALL SET(WL,WR,WB,WT,XLL,XRR,YBB,YTT,1)  

	call lwidth(2000)
C x1 axis
	call pro(0,0,0,x1,y1)	
	call pro(1.1,0,0,x2,y2)	
	CALL LINE(X1,Y1,X2,Y2)
	ang=atan2(y2-y1,x2-x1)/rad
	call pro(1.06,0,0,x2,y2)	
	call ploarrow(90.,270.,x2,y2,':1213:',ang,20.)
	call pro(1.15,0,0,x2,y2)	
	CALL PLCHHQ(x2,y2,':0330:',20.,0.,0.)	!x
	CALL PLCHHQ(x2+.05,y2-.05,':0234:',10.,0.,0.)	!1
C x2 axis
	call pro(0,1.1,0,x2,y2)	
	CALL LINE(X1,Y1,X2,Y2)
	ang=atan2(y2-y1,x2-x1)/rad
	call pro(0,1.08,0,x2,y2)
	call ploarrow(90.,270.,x2,y2,':1213:',ang,20.)
	call pro(0,1.15,0,x2,y2)
	CALL PLCHHQ(x2,y2,':0330:',20.,0.,0.)
	CALL PLCHHQ(x2+.05,y2-.05,':0235:',10.,0.,0.)	!2
C x3 axis
	call pro(0,0,1.44,x2,y2)	
	CALL LINE(X1,Y1,X2,Y2)
	ang=atan2(y2-y1,x2-x1)/rad
	call pro(0,0,1.42,x2,y2)
	call ploarrow(270.,90.,x2,y2,':1213:',ang,20.)
	call pro(0,0,1.52,x2,y2)
	CALL PLCHHQ(x2,y2,':0330:',20.,0.,0.)
	CALL PLCHHQ(x2+.05,y2-.05,':0236:',10.,0.,0.)	!3

c	CALL PLCHHQ(-0.8,1.4,char(igo+1),12.,0.,0.)	

C Plot the helix
	np=102	
	do i=1,np
	th=.1*(i-1)
	x=.5*cos(th)
	y=ifac*.5*sin(th)
	z=.1*th
	call pro(x,y,z,xpr,ypr)
	xp(i)=xpr
	yp(i)=ypr
	end do
	CALL CURVE(xp,yp,np)

	call lwidth(4000)
	kk=0
C PLot the unit vectors
	do i=ii1,np,idel
	kk=kk+1
	th=.1*(i-1)
	x=-.5*sin(th)
	y=ifac*.5*cos(th)
	z=.1*th
	x0=.5*cos(th)
	y0=ifac*.5*sin(th)
	z0=.1*th
C Tangent
	t1=x
	t2=y
	t3=z/th
	call norm(t1,t2,t3)
	call pro(x0,y0,z0,xpr,ypr)
	call pro(x0+t1,y0+t2,z0+t3,xx,yy)
	call line(xpr,ypr,xx,yy)
	ang=atan2(yy-ypr,xx-xpr)/rad
	call plchhq(xx,yy,':1213:',15.,ang-90.,0)

	if(kk.eq.3.and.igo.eq.0)then
	call lwidth(3000)  
	call plchhq(xx-.06,yy-.01,'t',10.,0.,0)
	call lwidth(4000)  
	end if
	
C Normal
	an1=-ifac*y
	an2=ifac*x
	an3=0
	call norm(an1,an2,an3)
	call pro(x0+an1,y0+an2,z0+an3,xx,yy)
        call gsplci(icolor)
	call lwidth(6000)  
	call line(xpr,ypr,xx,yy)
	ang=atan2(yy-ypr,xx-xpr)/rad
	call plchhq(xx,yy,':1213:',15.,ang-90.,0)
        call gsplci(0)
	call lwidth(4000)  

	if(kk.eq.3.and.igo.eq.0)then
	call lwidth(3000)  
	call plchhq(xx+.07,yy+.01,'n',10.,0.,0)
	call lwidth(4000)  
	end if
	
C Binormal
	b1=-t3*an2
	b2=t3*an1
	b3=t1*an2-t2*an1
	call norm(b1,b2,b3)
	call pro(x0+b1,y0+b2,z0+b3,xx,yy)
	ang=atan2(yy-ypr,xx-xpr)/rad
	call lined(xx,yy,xpr,ypr)
	call plchhq(xx,yy,':1213:',15.,ang-90.,0)

	if(kk.eq.3.and.igo.eq.0)then
	call lwidth(3000)  
	call plchhq(xx,yy+.1,'b',10.,0.,0)
	call lwidth(4000)  
	end if
		end do
	call lwidth(2000)

	WL=.6
	WR=1
	ifac=-1
	igo=1
	ii1=5	
	idel=22
	go to 1

999	call frame
	call clsgks
	stop
	end 

C Projection routine
	subroutine pro(x,y,z,xpr,ypr)
	common /proj/sinth,costh,sinph,cosph

	xpr=-x*costh+y*sinth
	ypr=-x*sinth*sinph-y*costh*sinph+z*cosph
	return
	end

	subroutine ploarrow(dang1,dang2,x2,y2,cchar,ang,size)
	character cchar*6
	dang=dang1
	if(ang.lt.0)dang=dang2
	CALL PLCHHQ(x2,y2,':1213:',size,ANG+dang,0.)
	return
	end

	subroutine lwidth(LINEWIDTH)
	CALL SETUSV('LW',LINEWIDTH)
	return
	end

C Normalize vector (t1,t2,t3)
	subroutine norm(t1,t2,t3)
	absv=sqrt(t1*t1+t2*t2+t3*t3)
	t1=.2*t1/absv
	t2=.2*t2/absv
	t3=.2*t3/absv
	return
	end
        subroutine dfclrs
C Define a set of RGB color triples for colors 1 through 15.
        dimension rgbv(3,15)
c       data rgbv /1  ,1  ,1,
        data rgbv /1  ,.75,.75,
     1             .7, .7, .7,
     1             .75,.5, 1,
     1             .5, 0,  1,
     1             0,  0,  1,
     1             0,  .5, 1,
     1             0,  1,  1,
     1             0,  1,  .6,
     1             0,  1,  0,
     1             .7, 1,  0,
     1             1,  1,  0,
     1             1,  .75,0,
     1             1,  .38,.38,
     1             1,  0,  .38,
     1             1,  0,  0/

        call gscr(1,0,0.,0.,0.)
        do i=1,15
        call gscr(1,i,rgbv(1,I),rgbv(2,I),rgbv(3,I))
        end do
        return
        end

