C Program love.f 
C Author: J. Pujol	
C Love waves in a layer over a half-space
C The S wave velocities are beta1 (layer) and beta2 (half-space)
C The thickness of the layer is h and the omega for Fig. 7.2a is 6.
C The ratio mu2/mu1 is taken as 2. For other values change the
C variable facmu

	dimension x3(1000),y3(1000),x(1000),y(1000),y2(1000),dif(1000)
        common pi,rad,twopi,beta1,b1sq,beta2,b2sq,h,fac2,
     1delmax,facmu
	common /cvel/omcut(10),nom(10),omvel(1000,4),phavel(1000,4),
     1k0(10) 
	character char*24,char1*1,char2*30,fname*10,cchar*2
        call dashdc('$''''''$',2,5)

c	print*,' Enter beta1 (layer) and beta2 (half-space), h, omega:'
c	read(5,*)beta1,beta2,h,omega
C Parameters for Fig. 7.2:
	beta1=3
	beta2=4
	h=10
	omega=6
	facmu=2	!should be mu2/mu1

	igo=0
999	if(igo.eq.2)go to 1000	

	if(omega.eq.0)go to 1000
	pi=4*atan(1.)
	rad=pi/180.
	twopi=2*pi
	b1sq=beta1**2
	b2sq=beta2**2
	fac=omega*h/beta1
	fac2=1-b1sq/b2sq
	delmax=sqrt(fac2)
	nmax=.5*((2*fac*delmax/pi)-1)+.5
	if(nmax.eq.0)nmax=1
	
		nmax=nmax+1
c	print*,' nmax,delmax :',nmax,delmax 
	nn=1000
	deldel=delmax/nn

	do i=1,nn-1
	x3(i)=i*deldel
	y3(i)=facmu*sqrt((fac2/x3(i)**2)-1)
	end do
	x3(nn)=i*deldel
	y3(nn)=0

        if(igo.eq.0)then
	CALL OPNGKS 
	CALL PLCHHQ(.5,.965,'Output of  love.f',10.,0,0.)       
c        CALL PLCHHQ(.5,.1,'Fig. 7-2b',10.,0.,0)	
c        CALL PLCHHQ(.5,.5,'Fig. 7-2a',10.,0.,0)	
	end if

	YB=-5
	xl=-x3(50)
	xrr=x3(nn)+x3(50)
	xr=x3(nn)+x3(100)

	WT=.9
	WB=0.4
	WL=0.1
	WR=1

c	CALL SET(WL,WR,WB,WT,XL,XR,YB,YT,1)  

	CALL SETUSV('MS',ISYMBSIZ)
	CALL PCSETI('CD',1)    !DUPLEX CHARACTER SET

C Generate all the positive branches of the tangents for delta < delta max
C n*pi/fac < delta < (2n+1)*pi/2fac  (this is a pi/2fac range)

	char=':    ::1120::0524::1116:'	!pi/xi
		step=rad/fac
		do j=1,nmax
		n=j-1

		delmin=n*pi/fac
c	print*,' n,delmin:',n,delmin

c Find intersection with continuous curve y2. The difference y2-y should change
c sign. The following is inefficient. It is somewhat better in subroutine phasevel
		do i=1,90
	x(i)=delmin+(i-1)*step
	y(i)=tan(fac*x(i))
          if(x(i).gt.0)then
        temp=(fac2/x(i)**2)-1
        if(temp.ge.0)then
        y2(i)=facmu*sqrt(temp)
        dif(i)=y2(i)-y(i)
        else
        go to 30
        end if
          end if
30		end do

	do i=1,89
	if(dif(i).ge.0.and.dif(i+1).le.0)then
	delf=dif(i)-dif(i+1)
	delx=abs(x(i)-x(i+1))
	x0=x(i)+dif(i)*delx/delf
	y0=facmu*sqrt((fac2/x0**2)-1)
	go to 10	
	end if
	end do

10	continue
	if(n.eq.0.and.igo.eq.0)then
	yt=y0+5
	CALL SET(WL,WR,WB,WT,XL,XR,YB,YT,1)  
	end if

C Label the modes
		if(igo.eq.0)then
	write(char1,'(i1)')n+1
        CALL PLCHHQ(x(90)+x3(7),yt-1,char1//':0743:',10.,0.,0)	! primed
		end if
		if(igo.eq.1)then
	write(char1,'(i1)')n+1
        CALL PLCHHQ(x(90)+x3(8),yt-1,char1,13.,0.,0)   !mode number umprimed
	if(n.eq.0)then
	CALL PLCHHQ(x(1),-1.3,':1033:',18.,0.,0)
	elseif(n.eq.1)then
	CALL PLCHHQ(x(1),-1.3,char(7:24),18.,0.,0)
	elseif(n.gt.1.and.n.le.4)then
	write(char(2:5),'(i4)')1033+n
	elseif(n.gt.4.and.n.le.9)then
	write(char(2:5),'(i4)')1035+n
	end if
        if(n.gt.1.and.n.lt.10)CALL PLCHHQ(x(1),-1.3,char,18.,0.,0)
		end if
C Label the points between those above
	char2=':    ::1120::0524::1035::1116:'	!pi/2xi
		if(igo.eq.1)then
		if(n.eq.nmax-1)go to 20
	call line(x(90)+step,0,x(90)+step,-.5)	
	if(n.eq.0)then
	CALL PLCHHQ(x(90)+step,-1.3,char2(7:30),18.,0.,0)
	elseif(n.eq.1)then
	write(char2(2:5),'(i4)')1033+2*n+1
	CALL PLCHHQ(x(90)+step,-1.3,char2,18.,0.,0)
	elseif(n.gt.1)then
	write(char2(2:5),'(i4)')1035+2*n+1
	CALL PLCHHQ(x(90)+step,-1.3,char2,18.,0.,0)
	end if
		end if
C Find the phase velocity
20	c=sqrt(b1sq/(1-x0**2))

C Clip y
	do i=1,90
	if(y(i).gt.yt)go to 15
	end do
15	n90=i
	y(n90)=yt
	if(igo.eq.1)then
	call line(x(1),0,x(1),-.5)	
        CALL PLCHHQ(x0,y0,':1331:',20.,0.,0)
	end if
	if(igo.eq.1)then
	CALL CURVE(x,y,n90)
	else
	CALL CURVEd(x,y,n90)
	end if
		end do

	call line(0,0,xrr,0)
        CALL plchhq(xrr-x3(5)+.002,0,':1213:',12.,-90.,0.) !arrow
        CALL plchhq(xrr+x3(12),0,':1106:',18.,0,0.) !delta
	call line(delmax,0,delmax,-.5)	
        CALL plchhq(delmax+x3(15),-1.5,':1106::B:max',18.,0,0.) !delta max
	call line(0,0,0,yt)

C Clip y3
	mm=0
	do i=1,nn
	if(y3(i).le.yt)then
	mm=mm+1
	x(mm)=x3(i)
	y(mm)=y3(i)
	end if
	end do
	
	CALL CURVE(x,y,mm)

	igo=igo+1
	omega=5
	go to 999

C Plot phase velocities for the first four modes
1000	wt=.35
	wb=0.1
        xl=-2
        xr=11
        yb=beta1-.3
        yt=beta2+.4
        CALL SET(WL,WR,WB,WT,XL,XR,YB,YT,1)
	
	do i=1,6
	xx=(i-1)*2
	call line(xx,beta1,xx,beta1-.05)
	if(xx.lt.10)then
	write(cchar(1:1),'(i1)')(i-1)*2
        CALL PLCHHQ(xx,beta1-.15,cchar(1:1),10.,0.,0)
	else
	write(cchar(1:2),'(i2)')(i-1)*2
        CALL PLCHHQ(xx,beta1-.15,cchar(1:2),10.,0.,0)
	end if
	end do

	call line(0,beta1,-.1,beta1)
	write(cchar(1:1),'(i1)')nint(beta1)
        CALL PLCHHQ(-0.25,beta1,cchar(1:1),10.,0.,0)
	call line(0,beta2,-.1,beta2)
	write(cchar(1:1),'(i1)')nint(beta2)
        CALL PLCHHQ(-0.25,beta2,cchar(1:1),10.,0.,0)

	call line(0,beta1,10.35,beta1)
        CALL plchhq(10.3+.02,beta1,':1213:',12.,-90.,0.) !arrow
        CALL plchhq(10.55,beta1,':1130:',18.,0,0.) !omega
	call line(0,beta1,0,beta2+.2)
        CALL plchhq(0,beta2+.18+.02,':1213:',12.,0.,0.) !arrow
        CALL plchhq(0,beta2+.28,'c',12.,0,0.) 

C Plot phase velocities
	call phasevel
                do j=1,4
	np=nom(j) 
        do i=1,np
        x(i)=omvel(i,j)
	y(i)=phavel(i,j)
        end do
	write(cchar(1:1),'(i1)')j
        CALL PLCHHQ(x(10),y(10)+.15,cchar(1:1),12.,0.,0)
	call lined(x(1),beta1,x(1),beta2)
        call curve(x,y,np)
                end do
	call frame
	call clsgks
	stop
	end 

C Compute phase velocities for first four modes. 
        subroutine phasevel
        common /cvel/ omcut(10),nom(10),omvel(1000,4),phavel(1000,4),
     1k0(10)
        common pi,rad,twopi,beta1,b1sq,beta2,b2sq,h,fac2,
     1delmax,facmu

c Find cutoff frequencies for first four modes
	do i=1,4
	omcut(i)=(i-1)*pi*beta1/(H*delmax)
        print*,' Cutoff frequency:',omcut(i)
	end do

C Generate all the positive branches of the tangents for delta < delta max
C n*pi/fac < delta < (2n+1)*pi/2fac  (this is a pi/2fac range)
	om0=0
	delom=.1
        nomega=100
        ommax=om0+nomega*delom
        do i=1,4
        nom0=1+omcut(i)/delom
C Number of frequencies for the i-th mode
        nom(i)=nomega-nom0+1
	nom(i)=nom(i)+1	!add the cutoff frequency
        omvel(1,i)=omcut(i)
	phavel(1,i)=beta2
        end do

	nmax=4
		do j=1,nmax
	do k=1,nomega
	omega=om0+k*delom
		if(omega.lt.omcut(j))go to 21
	k0(j)=k
	go to 22
21	end do
22		end do

                                do k=1,nomega
                                omega=om0+k*delom
				fac=omega*h/beta1
				step=rad/fac
                                if(step.gt..0001)step=.0001
		do j=1,nmax
		if(omega.lt.omcut(j))go to 100
                n=j-1

		delmin=n*pi/fac
c Find intersection with continuous curve y2. The difference y2-y should change
c sign
                do i=1,10000
        x2=delmin+(i-1)*step
        y=tan(fac*x2)

        if(x2.gt.0)then
        temp=(fac2/x2**2)-1
        if(temp.ge.0)y2=facmu*sqrt(temp)
	end if

        dif2=y2-y
        if(i.gt.1.and.dif1.ge.0.and.dif2.le.0)then
        ic=i
        go to 10
        end if
        dif1=dif2
        x1=x2
                end do
10        delf=dif1-dif2
C Interpolate
        delx=step       
        x0=x1+dif1*delx/delf
	temp=(fac2/x0**2)-1

	if(temp.ge.0)then
	y0=facmu*sqrt(temp)
	else
	end if

	y02=tan(fac*x0)
c        if(abs(y0-y02)/y0.gt..005)print*,y0,y,y02,y2

C Find the phase velocity
        temp=b1sq/(1-x0**2)
	if(temp.gt.0)then
	c=sqrt(temp)
	else
	c=temp
	end if
        omvel(k-k0(j)+2,j)=omega
	phavel(k-k0(j)+2,j)=c
100		end do
	               			end do

        return
	end
