C Program motion-pnt-src.f 
C Author: J. Pujol	
C P and S far field motion for a point source in the x3 direction

	dimension x(500),y(500),x2(500),y2(500)
	common rad,radinv
	pi=4*atan(1.)
	rad=pi/180
	radinv=1./rad
        CALL OPNGKS        
	CALL PLCHHQ(.5,.965,'Output of motion-pnt-src.f',10.,0,0.)
	CALL PCSETI('CD',1)    !DUPLEX CHARACTER SET
	LINEWIDTH=2000
	CALL SETUSV('LW',LINEWIDTH)
	np=181
	do i=1,np
	th=i-1
	r=sin(rad*th)
	x(i)=r*cos(rad*th)
	y(i)=r**2
	x2(i)=-x(i)
	y2(i)=-y(i)
	end do

	ddd=.015
	call line(.5,.4,.55,.4)
	call line(.5,.4,.5,.45)
	CALL PLCHHQ(.5,.445,':1213:',20.,0.,0.)	!up arrow
        CALL PLCHHQ(.5,.46,':PRU:u:B:3',10.,0.,0.)
	CALL PLCHHQ(.545,.4,':1213:',20.,270.,0.)
        CALL PLCHHQ(.55+ddd,.4,':PRU:u:B:1',10.,0.,0.)
c        CALL PLCHHQ(.5,.075,'Fig. 9-6',10.,0.,0.)

20	CALL SUB1
	call frame
	call clsgks
	STOP
	END

	SUBROUTINE SUB1
	dimension xx(500),yy(500)
	common rad,radinv
	character*7 cnum

	dx=.25
	dy=.25
	YB=-1-DY
	YT=1+DY
	xl=-1-DX
	xr=1+DX
	WB=.1
	WL=.1
	WT=.45	
	WR=.45

	ISYMBSIZ=100
	CALL SETUSV('MS',ISYMBSIZ)

	CALL SET(WL,WR,WB,WT,XL,XR,YB,YT,1)  

	LINEWIDTH=2000
	CALL SETUSV('LW',LINEWIDTH)

	r=.8
	np=360
	do i=1,np
	th=i-1
	yy(i)=R*sin(rad*th)
	xx(i)=R*cos(rad*th)
	end do
	call line (0,0,.4,0)
	call line (0,0,0,.4)
	call curve(xx,yy,np)
        CALL PLCHHQ(0,.485,':PRU:x:B:3',10.,0.,0.)
	CALL PLCHHQ(0,.4,':1213:',20.,0.,0.)
        CALL PLCHHQ(.5,0,':PRU:x:B:1',10.,0.,0.)
	CALL PLCHHQ(.4,0,':1213:',20.,270.,0.)
c        CALL PLCHHQ(0,-1.2,'(a)',10.,0.,0.)

	np=9

	do i=1,np
	th=(i-1)*22.5
	x1=r*sin(rad*th)
	y1=r*cos(rad*th)
	x2=x1+.125*sin(rad*2*th)
	y2=y1+.25*(cos(rad*th))**2
	call line (x1,y1,x2,y2)

	dang=270
	ang=radinv*atan2(y2,x2)
	if(ang.lt.0)dang=90
	CALL PLCHHQ(x2,y2,':1213:',25.,ANG+dang,0.)
	x1=-x1
	x2=-x2
	ang=radinv*atan2(y2,x2)
	dang=270
	if(ang.lt.0)dang=90
	call line (x1,y1,x2,y2)
	CALL PLCHHQ(x2,y2,':1213:',25.,ANG+dang,0.)
	end do

	WL=.6
	WR=.9
	WL=.575
	WR=.925
	CALL SET(WL,WR,WB,WT,XL,XR,YB,YT,1)  
	call curve(xx,yy,np)
	call line (0,0,.4,0)
	call line (0,0,0,.4)
        CALL PLCHHQ(0,.485,':PRU:x:B:3',10.,0.,0.)
	CALL PLCHHQ(0,.4,':1213:',20.,0.,0.)
        CALL PLCHHQ(.5,0.,':PRU:x:B:1',10.,0.,0.)
	CALL PLCHHQ(.4,0,':1213:',20.,270.,0.)
c        CALL PLCHHQ(0,-1.2,'(b)',10.,0.,0.)

	do i=1,np
	th=(i-1)*22.5
	x1=r*sin(rad*th)
	y1=r*cos(rad*th)
	x2=x1-.125*sin(rad*2*th)
	y2=y1+.25*(sin(rad*th))**2
	call line (x1,y1,x2,y2)
	dang=270
c	if(x1.eq.x2.and.y1.eq.y2)go to 35
	if(abs(x1-x2).lt.1.e-5.and.abs(y1-y2).lt.1.e-5)go to 35
	ang=radinv*atan2(y2-y1,x2-x1)
	if(ang.lt.0)dang=90
	CALL PLCHHQ(x2,y2,':1213:',25.,ANG+dang,0.)
35	x1=-x1
	x2=-x2
c	if(x1.eq.x2.and.y1.eq.y2)go to 40
	if(abs(x1-x2).lt.1.e-5.and.abs(y1-y2).lt.1.e-5)go to 40
	ang=radinv*atan2(y2-y1,x2-x1)
	dang=270
	call line (x1,y1,x2,y2)
	CALL PLCHHQ(x2,y2,':1213:',25.,ANG+dang,0.)
40	end do

	RETURN
	end 

