C Program p-free-s.f
C Author: J. Pujol
C Incident P waves; free surface. Reflection coefficients and particle
C motion at the free surface

	dimension a(500),b(500),u0(500),w0(500),ang(500),f2(500)
	COMMON /plot/ XL,XR,YB,YT,px,ppy,delinv
	character*14 char,char2*19
	call dashdc('$''''''$',2,5)

	print*,' Enter vp/vs:'
	read(5,*)vpvs
	alpha=4
	beta=alpha/vpvs
	albe=alpha/beta
	twoalbe=2*albe
	albe2=albe**2
	twoalbe2=2*albe2
	beal=beta/alpha
	pi=4*atan(1.)
	rad=pi/180.
	radinv=1./rad

	nang=181
	do i=1,nang
	ang(i)=(i-1)*.5	
	e=ang(i)*rad
	sine=sin(e)
	sin2e=sin(2*e)
	cose=cos(e)
	f=asin(beal*sine)
	f2(i)=2*f
	sin2f=sin(2*f)
	cos2f=cos(2*f)
	cos2f2=cos2f**2

	fac=1./(sin2e*sin2f+albe2*cos2f2)
	a(i)=(sin2e*sin2f-albe2*cos2f2)*fac
	b(i)=-twoalbe*sin2e*cos2f*fac

cccccccc	if(a(i).gt.0)print*,a(i),ang(i)

C Check energy eqn.
	if(i.gt.1)en=a(i)**2+(sin2f/sin2e)*b(i)**2
c	if(i.gt.i.and.abs(1.-en).gt.1.e-5)print*,' Energy equation:',i,en
	u0(i)=twoalbe2*cose*sin2f*fac
	w0(i)=-twoalbe2*cose*cos2f*fac
	end do

        CALL OPNGKS        
        CALL PLCHHQ(.5,.9,'P WAVE INCIDENT ON A FREE SURFACE',10.,0,0)
c	CALL PLCHHQ(.5,.2,'Fig. 6-2',10.,0,0)
	CALL PLCHHQ(.5,.965,'Output of p-free-s.f',10.,0,0.)
	XL=0
	XR=90
	YB=-2
	YT=2
	OFFX=20
	OFFY=-.6
	XLL=XL-OFFX
	XRR=XR+OFFX
	YBB=YB+OFFY
	YTT=YT-OFFY/2
	WT=.8
	WB=.3	
	WL=0
	WR=.5
	CALL SET(WL,WR,WB,WT,XLL,XRR,YBB,YTT,1)  
	
	PX=.5*(XL+XR)
	PPY=.5*(YB+YT)
	XLOFF=-.6
	PY=YB+xloff

	CALL PCSETI('CD',1)    !DUPLEX CHARACTER SET

	CALL SETUSV('LW',2000)
	call curve(ang,a,nang)
	call curve(ang,b,nang)
	call axes(1)
	CALL SETUSV('LW',1000)
	call line(xr,0,xl,0)

c	CALL PLCHHQ(20.,1.8,':701:/:702: = 1.732',10.,0,0)
	char2=':701:/:702: =      '
	write(char2(15:19),'(f5.3)')vpvs
	CALL PLCHHQ(20.,1.8,char2,10.,0,0)

	facx=xr-xl
	facy=yt-yb
	ang1=radinv*atan2(facx*(a(91)-a(89)),facy*(ang(91)-ang(89)))
	char='A:B1:1 /A'
	CALL PLCHHQ(ang(90),a(90)+.1,char(1:12),10.,ang1,0)
	ang1=radinv*atan2(facx*(b(91)-b(89)),facy*(ang(91)-ang(89)))
	char='B:B1:1 /A'
	CALL PLCHHQ(ang(90),b(90)+.13,char(1:12),10.,ang1,0)

C Plot reflection coefficients

	WL=.5
	WR=1
	CALL SET(WL,WR,WB,WT,XLL,XRR,YBB,YTT,1)  
c	CALL PLCHHQ(20.,1.8,':701:/:702: = 1.732',10.,0,0)
	CALL PLCHHQ(20.,1.8,char2,10.,0,0)
	CALL SETUSV('LW',2000)
	call curve(ang,w0,nang)
	call curve(ang,u0,nang)
	call curve(ang,w0,nang)

	CALL SETUSV('LW',1000)
	ang1=radinv*atan2(facx*(u0(61)-u0(59)),facy*(ang(61)-ang(59)))
c	char='u:B1:0 /A'
	char='u:B1:1:S1:0 /A'
	CALL PLCHHQ(ang(60),u0(60)+.12,char,10.,ang1,0)
	ang1=radinv*atan2(w0(61)-w0(59),ang(61)-ang(59))
c	char='w:B1:0 /A'
	char='u:B1:3:S1:0 /A'
	ang1=radinv*atan2(facx*(w0(61)-w0(59)),facy*(ang(61)-ang(59)))
	CALL PLCHHQ(ang(60),w0(60)+.12,char,10.,ang1,0)
C Angle f
C Scaling 
	delinv=2./90
	do i=1,nang
	f2(i)=delinv*f2(i)*radinv
	end do
	CALL SETUSV('LW',1000)
	call curve(ang,f2,nang)
	facy=.65*facy
	CALL SETUSV('LW',1000)
	ang1=radinv*atan2(facx*(f2(101)-f2(99)),facy*(ang(101)-ang(99))) 
c        CALL PLCHHQ(ang(100),f2(100)+.1,'2f:B5:1.732',10.,ang1,0)
        CALL PLCHHQ(ang(100),f2(100)+.1,'2f',10.,ang1,0)


	vpvs=2.5
	beta=alpha/vpvs
	beal=beta/alpha
	do i=1,nang
	e=ang(i)*rad
	sine=sin(e)
	f=asin(beal*sine)
	f2(i)=2*f*radinv*delinv
	end do
c        call curved(ang,f2,nang)
c        ang1=radinv*atan2(facx*(f2(110)-f2(90)),facy*(ang(110)-ang(90))) 
c        CALL PLCHHQ(ang(100),f2(100)-.1,'2f:B5:2.500',10.,ang1,0)

	call axes(2)
900	call frame
	call clsgks
	stop
	end 
c-------------------------------------------------------------------------------
	subroutine axes(ii)
	COMMON /plot/ XL,XR,YB,YT,px,ppy,delinv
	CHARACTER*4 CNUM

	LINEWIDTH=1000
	CALL SETUSV('LW',LINEWIDTH)
	CALL LINE(XL,YB,XR,YB)
	CALL LINE(XL,YT,XR,YT)
	CALL LINE(XL,YB,XL,YT)
	CALL LINE(XR,YB,XR,YT)
	CALL PLCHHQ(PX,yb-.5,'Incidence angle',10.,0.,0.)

	do i=1,10
	iang=(i-1)*10
	write(cnum(1:2),'(i2)')iang
	ang=iang
	call line(ang,yb,ang,yb-.1)
	CALL PLCHHQ(ang,yb-.3,CNUM(1:2),10.,0,0)	
	end do	

	do i=1,10
	amp=yb+(i-1)*.5
	write(cnum(1:4),'(f4.1)')amp
	call line(xl,amp,xl-2,amp)
	CALL PLCHHQ(xl-8,amp,CNUM(1:4),10.,0.,0)	
	end do	

		if(ii.eq.1)then
	CALL PLCHHQ(XL-17,PPY,'Refl. coeff.',10.,90.,0.)
	return
		elseif(ii.eq.2)then
c	CALL PLCHHQ(XL-17,PPY,'Amplitude',10.,90.,0.)
	CALL PLCHHQ(XL-17,PPY,'Surface Displ.',10.,90.,0.)
	ppy=yt/2

	CALL PLCHHQ(XR+15,PPY,'Angle 2f',10.,90.,0.)
	DO I=1,10
	IANG=(I-1)*10
	ANG=DELINV*iang
	CALL LINE(XR,ANG,XR+2,ANG)
	END DO
	DO I=1,4
	IANG=(I-1)*30
	ANG=DELINV*iang
	CALL LINE(XR,ANG,XR+1,ANG)
	write(CNUM(1:2),'(i2)')iang
	CALL PLCHHQ(XR+3,ANG,CNUM(1:2),10.,0,-1.)
	END DO
	return



		end if
	end
