C Program rad-31-3113.f
C Radiation patterns for the single couple 31 and the double couple 31-13
C Lower-hemisphere equal-area projection.
C Based on programs written by B. Kennett (see Kennett, B., 1988, Radiation from 
C a moment-tensor source, in: D. Doornbos, Ed., Seismological algorithms, Academic 
C Press, 427-441.) The original programs can be downloaded from
C http://orfeus.knmi.nl/other.services/software.shtml (click on Seismological algorithms) 
C The conversion to NCAR and the polarization angle, fault planes and P, B, T axes 
C are due to J.P.

	dimension xp(500),yp(500),angle(500),sz(500),fp(500),fs(500),
     1fh(500),azim(500),xtbp(3),ytbp(3),chstr(3)
	COMMON /FOCAL/ STRK(2),FDIP(2),SLIP(2)
      common /memo/ xor,yor,Header,RAD,FAC
      common /info/ strike,dip,rake,st,di,ra,tmc,                       
     &              tmxx,tmxy,tmxz,tmyx,tmyy,tmyz,tmzx,tmzy,tmzz        
      character*30 Header                                               
      character*1 IANS,ISIZ,chstr*6                                             

        pi=4*atan(1.)
        pprad=180/pi
	DGR =pi/180  
	pi2=pi/2
        chstr(1)=':1245:'       !dot
        chstr(2)=':0541:'       !triangle
        chstr(3)=':1331:'       !circle

	ips=4
	print*,' Enter 1 for single couple 31; 2 for double couple 13+31:'
	read(5,*)ifor      

	  CALL OPNGKS  
 	CALL PLCHHQ(.5,.985,'Output of rad-31-1331.f',10.,0,0.)     
	if(ifor.eq.1)then
 	CALL PLCHHQ(.5,.96,'Single couple 31',10.,0,0.) 
c        call plCHHQ(.5,.05,'Fig. 10-6',10.,0,0.)
	else
 	CALL PLCHHQ(.5,.96,'Double couple 13+31',10.,0,0.) 
c        call plCHHQ(.5,.05,'Fig. 10-7',10.,0,0.)
	end if

	rad=.2
	PRAD = RAD*SQRT(2.0) 
	YB=0
	YT=1
	xl=0
	xr=1

	WT=.9
	WB=0.1
	WL=0.1
	WR=.9

	LINEWIDTH=1500
	CALL SETUSV('LW',LINEWIDTH)
	ISYMBSIZ=100
	CALL SETUSV('MS',ISYMBSIZ)

	CALL PCSETI('CD',1)    !DUPLEX CHARACTER SET

	CALL SET(WL,WR,WB,WT,XL,XR,YB,YT,1)  

	LINEWIDTH=2000
	CALL SETUSV('LW',LINEWIDTH)

C      DRAW SOURCE RADIATION PATTERNS                                   
	GO TO (1000,2000,3000,1000),IPS
C                                      P WAVES                          
1000	x0=0.25
	y0=0.75

	if(ifor.eq.2)then
	th0=dgr*45
	ph0=0
          PR = PRAD*SIN(0.5*th0)
          ytbp(1) =PR*COS(ph0)	!T
          xtbp(1) =PR*SIN(ph0)
	ph0=dgr*180
          ytbp(3) =PR*COS(ph0)	!P
          xtbp(3) =PR*SIN(ph0)
	th0=dgr*90
	ph0=dgr*90
          PR = PRAD*SIN(0.5*th0)
          ytbp(2) =PR*COS(ph0)	!B
          xtbp(2) =PR*SIN(ph0)
	end if

	call circle(x0,y0,rad)
	CALL SETUSV('LW',3000)
	call plCHHQ(x0+rad,y0+rad,'P',25.,0,0.)
	CALL SETUSV('LW',2000)
	i=0
	do 10 PHI = 0.0,360.0,10.0					!
        PH = DGR*PHI                                                    
        PHST = PH - ST                                                  
        do 20 TXI =  5.0,86.0,10.0                                      
	i=i+1
	azim(i)=ph
          TX = DGR*TXI                                                  
	fp(i)=sin(2*tx)*cos(ph)
	if(ifor.eq.1)fp(i)=.5*fp(i)
c                              equal area projection                    
          PR = PRAD*SIN(0.5*TX)                                         
          YP(i) =PR*COS(PH)                                               
          XP(i) =PR*SIN(PH)                                               
          angle(i) = 0.0                                                   
	sz(i)=abs(fp(i))
 20     continue                                                        
 10   continue
	nn=i

                do j=1,nn
32      format(i5,f8.3)
          IF(FP(j).GT.0.0) then                                            
	call plus(x0+xp(j),y0+yp(j),sz(j))
          ELSE IF (FP(j).LT.0.0) then                                      
	call minus(x0+xp(j),y0+yp(j),sz(j))
          END IF                                                        
		end do

	if(ifor.eq.2)then
        do j=1,3
        call plCHHQ(x0+xtbp(j),y0+ytbp(j),chstr(j),20.,0,0.)
        end do
	end if

	IF(IPS.EQ.4)THEN
	GO TO 2000
	ELSE
	GO TO 4000
	END IF
C                                      SV WAVES                         
2000	x0=0.75
	y0=0.25
	call circle(x0,y0,rad)
	CALL SETUSV('LW',3000)
	call plCHHQ(x0+rad,y0+rad,'SV',25.,0,0.)
	CALL SETUSV('LW',2000)
	i=0
	do 30 PHI = 0.0,360.0,10.0                                      
        PH = DGR*PHI                                                    
        PHST = PH - ST                                                  
        do 40 TXI =  5.0,86.0,10.0                                      
	i=i+1
          TX = DGR*TXI                                                  
	if(ifor.eq.1)then
	fs(i)=-(sin(tx))**2*cos(ph)
	else
	fs(i)=cos(2*tx)*cos(ph)
	end if
c                              equal area projection                    
          PR = PRAD*SIN(0.5*TX)                                         
          YP(i) =PR*COS(PH)                                               
          XP(i) =PR*SIN(PH)                                               
	sz(i)=abs(fs(i))
          IF(FS(i).GT.0.0) then                                            
          ANGLE(i) = 1.5707963-ph                                          
          ELSE IF(FS(i).LT.0.0) then                                       
          ANGLE(i)=4.7123889-ph                                            
          END IF                                                        
 40     continue                                                        
 30   continue                                                          
		nn=i
c		do j=1,nn
c	call arrow(x0+xp(j),y0+yp(j),sz(j),angle(j))
c		end do

	if(ifor.eq.2)then
        do j=1,3
        call plCHHQ(x0+xtbp(j),y0+ytbp(j),chstr(j),20.,0,0.)
        end do
	end if
                do j=1,nn
          IF(Fs(j).GT.0.0) then                                            
	call plus(x0+xp(j),y0+yp(j),sz(j))
          ELSE IF (Fs(j).LT.0.0) then                                      
	call minus(x0+xp(j),y0+yp(j),sz(j))
          END IF                                                        
               end do

	IF(IPS.EQ.4)THEN
	GO TO 3000
	ELSE
	GO TO 4000
	END IF
C                                      SH WAVES                         
3000	x0=0.75
	y0=0.75
	call circle(x0,y0,rad)
	CALL SETUSV('LW',3000)
	call plCHHQ(x0+rad,y0+rad,'SH',25.,0,0.)
	CALL SETUSV('LW',2000)
	i=0
	do 50 PHI = 0.0,360.0,10.0                                      
        PH = DGR*PHI                                                    
        PHST = PH - ST                                                  
        do 60 TXI =  5.0,86.0,10.0                                      
	i=i+1
          TX = DGR*TXI                                                  
	if(ifor.eq.1)then
	fh(i)=0
	else
	fh(i)=-cos(tx)*sin(ph)
	end if

c                              equal area projection                    
          PR = PRAD*SIN(0.5*TX)                                         
          YP(i) =PR*COS(PH)                                               
          XP(i) =PR*SIN(PH)                                               
	sz(i)=abs(fh(i))
          IF(FH(i).GT.0.0) then                                            
            angle(i) = -ph                                                 
          ELSE IF(FH(i).LT.0.0) then                                       
            angle(i)=3.1415927-ph                                          
          END IF                                                        
 60     continue                                                        
 50   continue                                                          
		nn=i

	if(ifor.eq.2)then
        do j=1,3
        call plCHHQ(x0+xtbp(j),y0+ytbp(j),chstr(j),20.,0,0.)
        end do
	end if
                do j=1,nn
          IF(Fh(j).GT.0.0) then                                            
	call plus(x0+xp(j),y0+yp(j),sz(j))
          ELSE IF (Fh(j).LT.0.0) then                                      
	call minus(x0+xp(j),y0+yp(j),sz(j))
          END IF                                                        
               end do

4000	x0=.25
	y0=.25
	CALL SETUSV('LW',3000)
	call plCHHQ(x0+rad,y0+rad,':0705:',35.,0,0.)
	CALL SETUSV('LW',2000)

	if(ifor.eq.2)then
        do j=1,3
        call plCHHQ(x0+xtbp(j),y0+ytbp(j),chstr(j),20.,0,0.)
        end do
	end if

c Polarization
	call circle(x0,y0,rad)
	do j=1,nn,2
	if(abs(fh(j)).lt.1.e-5.and.abs(fs(j)).lt.1.e-5)go to 21
	ang=atan2(fh(j),fs(j))
	amp=sqrt(fh(j)**2+fs(j)**2)
	go to 22
21	amp=0
22	call polar(x0+xp(j),y0+yp(j),ang+azim(j),amp)
	end do

	call frame
	call clsgks
      STOP                                                              
      END                                                               

	subroutine circle(x0,y0,rad)
	parameter (np=361)
	dimension x(np),y(np)
        ppi=4*atan(1.)
        pprad=180/ppi
	do i=1,np
	ang=i
	x(i)=x0+rad*cos(ang/pprad)
	y(i)=y0+rad*sin(ang/pprad)
	end do
	call curve(x,y,np)

        call line(x(1),y(1),x0+1.04*rad,y(1))
        call plCHHQ(x0+1.1*rad,y0,'E',15.,0,0.)
        call line(x0-rad,y0,x0-1.04*rad,y0)
        call plCHHQ(x0-1.13*rad,y0,'W',15.,0,0.)
        call line(x0,y0+rad,x0,y0+1.04*rad)
        call plCHHQ(x0,y0+1.1*rad,'N',15.,0,0.)
        call line(x0,y0-rad,x0,y0-1.04*rad)
        call plCHHQ(x0,y0-1.15*rad,'S',15.,0,0.)

	return
	end
c ==============================================================================
	subroutine arrow(xp,yp,sz,angle)
c Based on the original subroutine bsymbol
        szc=0.0075*sz*cos(angle)
        szs=0.0075*sz*sin(angle)
        call line(xp,yp,xp+szc,yp+szs)
        call line(xp,yp,xp-szc,yp-szs)
        call line(xp-szs,yp+szc,xp-szs,yp+szc)
        call line(xp-szs,yp+szc,xp+szc,yp+szs)
        call line(xp+szc,yp+szs,xp+szs,yp-szc)
        return
	end
c ==============================================================================
	subroutine plus(xp,yp,sz)
c Based on the original subroutine bsymbol
        szz=0.0075*sz
        call line(xp-szz,yp,xp+szz,yp)
        call line(xp,yp-szz,xp,yp++szz)
        return
	end
c ==============================================================================
	subroutine minus(xp,yp,sz)
c Based on the original subroutine bsymbol
        szz=0.0075*sz
        call line(xp-szz,yp,xp+szz,yp)
        return
	end
c ==============================================================================
	subroutine polar(xp,yp,angle,sz)
c Based on the original subroutine bsymbol
        szs=0.0075*cos(angle)*sz
        szc=0.0075*sin(angle)*sz
        call line(xp,yp,xp+szc,yp+szs)
        call line(xp,yp,xp-szc,yp-szs)
        return
	end
