C Program rad-sing-cple.f
C Author: J. Pujol	
C Radiation patterns (2D) for M31

	dimension x(500),y(500),x2(500),y2(500),x3(500),y3(500),char(4),rr(4),r(500)
	character*1 char

	pi=4*atan(1.)
	rad=pi/180
        call dashdc('$''''''$',2,5)
        CALL OPNGKS     
	CALL PLCHHQ(.5,.965,'Output of rad-sing-cple.f',10.,0,0.)    
	CALL PCSETI('CD',1)    !DUPLEX CHARACTER SET
	LINEWIDTH=2000
	CALL SETUSV('LW',LINEWIDTH)
	np=181
	cosphi0=cos(rad*0.)
	i=0
	do j=1,np
	i=i+1
	th=j-1
	r(i)=.5*sin(rad*2*th)*cosphi0
	if(th.eq.45.)rr(1)=r(i)
	if(th.eq.135)rr(2)=r(i)
	x(i)=r(i)*sin(rad*th)
	y(i)=r(i)*cos(rad*th)
	end do

	cosphi1=cos(rad*180.)
	do j=1,np
	i=i+1
	th=j-1
	r(i)=.5*sin(rad*2*th)*cosphi1
	if(th.eq.45.)rr(3)=r(i)
	if(th.eq.135)rr(4)=r(i)
	x(i)=r(i)*sin(rad*th)
	y(i)=r(i)*cos(rad*th)
	end do
	np2=2*np-1

	do i=1,90
	x(i)=abs(x(i))
	y(i)=abs(y(i))
	end do
	do i=91,180
	x(i)=abs(x(i))
	y(i)=-abs(y(i))
	end do
	do i=181,270
	x(i)=-abs(x(i))
	y(i)=abs(y(i))
	end do
	do i=271,360
	x(i)=-abs(x(i))
	y(i)=-abs(y(i))
	end do

	do i=1,4
	char(i)='-'
	if(rr(i).gt.0)char(i)='+'
	end do

c        CALL PLCHHQ(.225,.535,'(a)',10.,0.,0.)
c        CALL PLCHHQ(.775,.535,'(b)',10.,0.,0.)
c        CALL PLCHHQ(.5,.51,'Fig. 9-12',10.,0.,0.)
	WL=.05
	WR=.4
	WB=.55
	WT=.9

	dx=.15
	dy=.15
	dx2=.3
	dy2=.3
	YB=-1-DY2
	YT=1+DY2
	xl=-1-DX2
	xr=1+DX2

	LINEWIDTH=2000
	CALL SETUSV('LW',LINEWIDTH)

10	PRINT*,' WL,WR,WB,WT:',WL,WR,WB,WT

	LINEWIDTH=2000
	CALL SETUSV('LW',LINEWIDTH)
	ISYMBSIZ=100
	CALL SETUSV('MS',ISYMBSIZ)

	CALL SET(WL,WR,WB,WT,XL,XR,YB,YT,1)  

	CALL LINE(XL+DX,0.,XR-DX,0.)
	CALL LINE(0,YB+DY,0,YT-DY)
	CALL PLCHHQ(0,YT-DY,':1213:',20.,0.,0.)	!up arrow
        CALL PLCHHQ(0,YT-DY+.085,':PRU:x:B:3',10.,0.,0.)
	CALL PLCHHQ(XR-DX,0,':1213:',20.,270.,0.)
        CALL PLCHHQ(XR-DX+.1,0.,':PRU:x:B:1',10.,0.,0.)
	
	CALL PCSETI('CD',1)

	if(igo.eq.0)then
        CALL PLCHHQ(x(45)+.05,y(45)+.05,char(1),12.,0.,0.)
        CALL PLCHHQ(x(135)+.05,y(135)-.05,char(2),12.,0.,0.)
        CALL PLCHHQ(x(225)-.05,y(225)+.05,char(3),12.,0.,0.)
        CALL PLCHHQ(x(315)-.05,y(315)-.05,char(4),12.,0.,0.)
	else
        CALL PLCHHQ(x(90)+.06,y(90)+.06,char(1),12.,0.,0.)
        CALL PLCHHQ(x(270)-.06,y(270)+.06,char(3),12.,0.,0.)
	end if

	LINEWIDTH=4000
	if(igo.eq.0)then
	CALL SETUSV('LW',LINEWIDTH)
	call line(.05,0,.05,.12)		!couple 31		
        CALL PLCHHQ(.05,.11,':1213:',7.,90.-90,0.)  !arrow
	call line(-.05,0,-.05,-.12)
        CALL PLCHHQ(-.05,-.11,':1213:',7.,270.-90,0.)  !arrow
	end if

	LINEWIDTH=2000
	CALL SETUSV('LW',LINEWIDTH)

	CALL CURVE(x,y,np2)

	IGO=IGO+1
	IF(IGO.EQ.2)GO TO 20

	i=0
	do j=1,np
	i=i+1
	th=j-1
	r(i)=-sin(rad*th)**2*cosphi0
	if(th.eq.45.)rr(1)=r(i)
	if(th.eq.135)rr(2)=r(i)
	x(i)=r(i)*sin(rad*th)
	y(i)=r(i)*cos(rad*th)
	end do

	cosphi1=cos(rad*180.)
	do j=1,np
	i=i+1
	th=j-1
	r(i)=-sin(rad*th)**2*cosphi1
	if(th.eq.45.)rr(3)=r(i)
	if(th.eq.135)rr(4)=r(i)
	x(i)=r(i)*sin(rad*th)
	y(i)=r(i)*cos(rad*th)
	end do
	np2=2*np-1

	do i=1,90
	x(i)=abs(x(i))
	y(i)=abs(y(i))
	end do
	do i=91,180
	x(i)=abs(x(i))
	y(i)=-abs(y(i))
	end do
	do i=181,270
	x(i)=-abs(x(i))
	y(i)=abs(y(i))
	end do
	do i=271,360
	x(i)=-abs(x(i))
	y(i)=-abs(y(i))
	end do

	do i=1,4
	char(i)='-'
	if(rr(i).gt.0)char(i)='+'
	end do


	WL=.6
	WR=.95
	GO TO 10

20	call frame
	call clsgks
	STOP
	END
