%Program rad_dble_cple.m
%Author: J. Pujol
%P and S Radiation patterns for the double couple 31-13 (MATLAB)

clf reset 

n=30
ish=0
			for k=1:4
			ish=ish+1	
%ish=input('1: P 13-31; 2: S 13-31; 3: SV 13-31; 4: SH 13-31; 6:stop')
th=pi*(0:1:n)/n;
phi=pi*(0:2:2*n)'/n;

%Next line: P of 13-31
if ish==1
r=abs(cos(phi)*sin(2*th));
elseif ish==2
%Next line: |S| of 13-31
r=sqrt(cos(phi).^2*cos(2*th).^2 + sin(phi).^2*cos(th).^2);
elseif ish==3
%Next line: SV of 13-31
r=abs(cos(phi)*cos(2*th));
elseif ish==4
%Next line: SH of 13-31
r=abs(sin(phi)*cos(th));
elseif ish==5
%Next three lines: sqrt(SH^2 +SV^2) of 13-31
r1=sin(phi)*cos(th);
r2=cos(phi)*cos(2*th);
r=sqrt(r1.^2+r2.^2);
elseif ish==6
break
end

x=abs(r).*(cos(phi)*sin(th));
y=abs(r).*(sin(phi)*sin(th));
z=abs(r).*(ones(size(phi))*cos(th));

subplot(2,2,ish)

view([135 15])

xlabel('x1')
ylabel('x2')
zlabel('x3')

axis ([-1 1 -1 1 -1 1])
axis('off')
hold on

if ish==1
%text('Position',[0.15 0 -1.7],'String','(a)')
text('Position',[1.75 0 1.4],'String','\it P')
end
if ish==2
%text('Position',[0.15 0 -1.7],'String','(b)')
text('Position',[1.75 0 1.4],'String','\it S')
end  
if ish==3
%text('Position',[-2.5 0 -2.5],'String','Fig. 9-13')
text('Position',[-2.5 0 -2.5],'String','Output of rad\_dble\_cple.m')
%text('Position',[0.15 0 -1.7],'String','(c)')
text('Position',[1.75 0 1.4],'String','\it SV')
end
if ish==4
%text('Position',[0.15 0 -1.7],'String','(d)')
text('Position',[1.75 0 1.4],'String','\it SH')
end

text('Position',[0.058 0 1.49],'String','x_3')
text('Position',[1.75 0 -.077],'String','x_1')
text('Position',[0 1.6 -.1],'String','x_2')
x1(1)=0;
x1(2)=0;
y1(1)=-1.5;
y1(2)=1.5;
z1(1)=0;
z1(2)=0;
plot3(x1,y1,z1,'-')	%,'color','red')

x1(1)=-1.5;
x1(2)=1.5;
y1(1)=0;
y1(2)=0;
z1(1)=0;
z1(2)=0;
plot3(x1,y1,z1,'-')

x1(1)=0;
x1(2)=0;
y1(1)=0;
y1(2)=0;
z1(1)=-1.5;
z1(2)=1.5;
plot3(x1,y1,z1,'-')

surf(x,y,z);
hold off


end

