C Program sv-free-s.f
C Author: J. Pujol
C Incident SV waves; free surface.  Reflection coefficients and particle
C motion at the free surface.

	dimension xt(1000),yt1(1000),yt2(1000),yt3(1000),yt4(1000)
	COMMON refp(1000),refs(1000),chi(1000),x(1000),xc(1000),refpc(1000)
     1,refsc(1000)
     1,u0(1000),w0(1000),uu0(1000),ww0(1000),uphase(1000),wphase(1000)
     1,uphasec(1000),wphasec(1000)
	complex refpc,refsc,refp,refs
	COMMON /plot/ XL,XR,YB,YT,FC,NN,IC,px,ppy,delinv
	COMMON /VEL/ALBE,ALBE2,BEAL,BEAL2,RAD,RADINV
        character*18 char,char2*23
	call dashdc('$''''''$',2,5)

	print*,' Enter vp/vs:'
	read(5,*)vpvs

	alpha=4
	beta=alpha/vpvs
	albe=alpha/beta
	albe2=albe**2
	beal=beta/alpha
	beal2=beal**2
C fc = critical angle
	fc=asin(beal)
	pi=4*atan(1.)
	rad=pi/180.
	radinv=1./rad
 
	CALL SWINC

        CALL OPNGKS        
        CALL PLCHHQ(.5,.9,'SV WAVE INCIDENT ON A FREE SURFACE',10.,0,0)
        CALL PLCHHQ(.5,.965,'Output of sv-free-s.f',10.,0,0.)
c        CALL PLCHHQ(.5,.2,'Fig. 6-4',10.,0,0)
	char2=':701:/:702: =      '
	write(char2(15:19),'(f5.3)')vpvs
	CALL PLCHHQ(.5,.865,char2(1:19),10.,0,0)

	XL=0
	XR=90
	YB=0
	YT=5	!4.8
	OFFX=20
	OFFY=-.6
	XLL=XL-OFFX
	XRR=XR+OFFX
	YBB=YB+OFFY
	YTT=YT-OFFY/2
	WT=.8
	WB=.3	
	WL=.5
	WR=1
	CALL SET(WL,WR,WB,WT,XLL,XRR,YBB,YTT,1)  
	
	PX=.5*(XL+XR)
	PPY=.5*(YB+YT)
	XLOFF=-.6
	PY=YB+xloff

	CALL PCSETI('CD',1)    !DUPLEX CHARACTER SET

c Scale the vertical axis
	DELY=380/(YT-YB)
	DELINV=1./DELY
		
	call axes
c			if(igo.eq.0)go to 900
20	DO I=1,IC
	wphasec(I)=DELINV*(wphasec(I)+190)
	uphasec(I)=DELINV*(uphasec(I)+190)
	END DO
	DO I=1,nn
	wphase(I)=DELINV*(wphase(I)+190)
	uphase(I)=DELINV*(uphase(I)+190)
	END DO

	nt=0
	do i=1,nn
	nt=nt+1
	xt(nt)=x(i)
	yt1(nt)=u0(i)
	yt2(nt)=w0(i)
	yt3(nt)=uphase(i)
	yt4(nt)=wphase(i)
	end do
	do i=1,ic
	nt=nt+1
	xt(nt)=xc(i)
	yt1(nt)=uu0(i)
	yt2(nt)=ww0(i)
	yt3(nt)=uphasec(i)
	yt4(nt)=wphasec(i)
	end do
	CALL SETUSV('LW',3000)
	call curve(xt,yt1,nt)
	call curved(xt,yt3,nt-1)
	CALL SETUSV('LW',1000)
	call curve(xt,yt2,nt)
	call curved(xt,yt4,nt)

        facx=xr-xl
        facy=yt-yb
	CALL SETUSV('LW',1500)

	char2=':725::B6:u:B1:1:S1:0 /B'
        ang1=radinv*
     1atan2(facx*(yt3(120)-yt3(110)),facy*(xt(120)-xt(110)))
        CALL PLCHHQ(xt(100),yt3(100)+.2,char2,12.,ang1,0)
        CALL PLCHHQ(xt(485),3.,char2,12.,90.,0)

	char2=':725::B6:u:B1:3:S1:0 /B'
        ang1=radinv*
     1atan2(facx*(yt4(120)-yt4(110)),facy*(xt(120)-xt(110)))
        CALL PLCHHQ(xt(100),yt4(100)-.15,char2,12.,ang1,0)
        ang1=radinv*
     1atan2(facx*(yt4(650)-yt4(640)),facy*(xt(650)-xt(640)))
        CALL PLCHHQ(xt(645),yt4(645)+.2,char2,12.,ang1,0)

	char='|u:B1:0 /B|'
	char='|u:B1:1:S1:0 /B|'
        ang1=radinv*
     1atan2(facx*(yt1(550)-yt1(540)),facy*(xt(550)-xt(540)))
        CALL PLCHHQ(xt(545),yt1(545)+.18,char(1:16),10.,ang1,0)

	char='|w:B1:0 /B|'
	char='|u:B1:3:S1:0 /B|'
        ang1=radinv*
     1atan2(facx*(yt2(120)-yt2(110)),facy*(xt(120)-xt(110)))
        CALL PLCHHQ(xt(100),yt2(100)+.2,char(1:16),10.,ang1,0)

C Plot amplitude and phase of reflection coefficients
	WL=0
	WR=.5
c	wr=.95
	CALL SET(WL,WR,WB,WT,XLL,XRR,YBB,YTT,1)  
	
	call axes

	nt=0
	DO I=1,nn
	nt=nt+1
	call phamp(refp(i),phase,amp)
	yt1(nt)=amp
	yt3(nt)=DELINV*(phase+190)
	call phamp(refs(i),phase,amp)
	uphase(I)=DELINV*(phase+190)
	yt2(nt)=amp
	yt4(nt)=DELINV*(phase+190)
	END DO

	DO I=1,IC
	nt=nt+1
	call phamp(refpc(i),phase,amp)
	yt1(nt)=amp
	yt3(nt)=DELINV*(phase+190)
	call phamp(refsc(i),phase,amp)
	yt2(nt)=amp
	yt4(nt)=DELINV*(phase+190)
	END DO
	CALL SETUSV('LW',1000)

	CALL SETUSV('LW',3000)
	call curve(xt,yt1,nt)	!abs. value of refp
	call curved(xt,yt3,nt-1)	!phase of refp
	CALL SETUSV('LW',1000)
	call curve(xt,yt2,nt)	!abs. value of refs
	call curved(xt,yt4,nt-1)	!phase of refs

	CALL SETUSV('LW',1500)
	char=':725::B5:B:B1:1 /B'
c        CALL PLCHHQ(xt(260),3.75,char,12.,90.,0)
        CALL PLCHHQ(xt(260),1.75,char,12.,90.,0)
        ang1=radinv*
     1atan2(facx*(yt4(650)-yt4(640)),facy*(xt(650)-xt(640)))
        CALL PLCHHQ(xt(645),yt4(645)+.22,char,12.,ang1,0)

	char=':725::B5:A:B1:1 /B'
        CALL PLCHHQ(xt(100),yt3(100)+.2,char,12.,0.,0)
        CALL PLCHHQ(xt(485),3.,char,12.,90.,0)

	char='|A:B1:1 /B|'
        ang1=radinv*
     1atan2(facx*(yt1(550)-yt1(540)),facy*(xt(550)-xt(540)))
        CALL PLCHHQ(xt(545),yt1(545)+.18,char(1:11),10.,ang1,0)

	char='|B:B1:1 /B|'
        ang1=radinv*
     1atan2(facx*(yt2(120)-yt2(110)),facy*(xt(120)-xt(110)))
        CALL PLCHHQ(xt(100),yt2(100)+.18,char(1:11),10.,ang1,0)

900	call frame
	call clsgks
	stop
	end 
c-------------------------------------------------------------------------------
	SUBROUTINE SWINC
	COMMON refp(1000),refs(1000),chi(1000),x(1000),xc(1000),refpc(1000)
     1,refsc(1000)
     1,u0(1000),w0(1000),uu0(1000),ww0(1000),uphase(1000),wphase(1000)
     1,uphasec(1000),wphasec(1000)
	complex refpc,refsc,refp,refs
	COMMON /plot/ XL,XR,YB,YT,FC,NN,IC,px,ppy,delinv
	COMMON /VEL/ALBE,ALBE2,BEAL,BEAL2,RAD,RADINV
	complex uu,ww,ccose,one,ci,rrefp,rrefs

	pi2=2*atan(1.)
	one=cmplx(1.,0.)
	ci=cmplx(0.,1.)
	fac=2*albe
	fac2=2*albe2
	fcrad=fc*radinv
	rmin=1000	
	delf=.1
	nn=fcrad/delf

C Before critical angle
		do i=1,nn+1	!last value to be used for uu0,ww0
	f=rad*(i-1)*delf
	x(i)=radinv*f
	sinf=sin(f)
c	sinf2=sinf**2
	sin2f=sin(2*f)
	sin4f=sin(4*f)
	cosf=cos(f)
	cos2f=cos(2*f)
	e=asin(albe*sinf)
	sin2e=sin(2*e)
	sine=sin(e)
	cose=cos(e)
	cos2f2=cos2f**2  
	denom=1./(sin2e*sin2f+albe2*cos2f2)
	refpi=denom*albe*sin4f
	refsi=denom*(sin2e*sin2f-albe2*cos2f2)
	u0(i)=denom*fac2*cosf*cos2f
	w0(i)=denom*fac*cose*sin2f
	uphase(i)=radinv*atan2(0.,u0(i))
	if(w0(i).ne.0)wphase(i)=radinv*atan2(0.,w0(i))
	uu=cosf+sine*refpi-cosf*refsi
	ww=sinf+cose*refpi+sinf*refsi
	if(abs(u0(i)-uu).gt.1.e-6)print*,i,u0(i),uu
	if(abs(w0(i)-ww).gt.1.e-6)print*,i,w0(i),ww
	if(abs(refsi).le.rmin)rmin=abs(refsi)
	refp(i)=one*refpi
	refs(i)=one*refsi
		end do

C At and after critical angle
	ic=1
	xc(1)=fcrad
	chi(1)=90	
	refpc(ic)=one*4*sqrt(1-beal2)/(albe2-2)
	refsc(ic)=cmplx(-1.,-0.000001)
	sine=albe*sin(fc)
	uu0(ic)=one*cos(fc)-cos(fc)*refsc(ic)+one*refpc(ic)*sine  

	ww0(ic)=0	!See eqn. for displacement, at fc: sine=0, B1/B=-1
	uphasec(ic)=radinv*atan2(0.,uu0(ic))
C At the critical angle the real part of w0 is zero and the imag. part is < 0!!
	wphasec(ic)=radinv*atan2(-0.00001,0.) 

		do i=nn+2,90./delf-1
	f=rad*i*delf
	ic=ic+1
	xc(ic)=radinv*f
	sinf=sin(f)
	sinf2=sinf**2
	cos2f=cos(2*f)
	cosf=cos(f)
	tan2f=tan(2*f)
	cot2f=1./tan2f
	sine=albe*sinf
	chi(ic)=atan((cos2f*cot2f)/(2*sinf*sqrt(sinf2-beal2)))
	sinchi=sin(chi(ic))
	coschi=cos(chi(ic))
c	refpc(ic)=2*beal*tan2f*sinchi
	rrefp=2*beal*tan2f*sinchi*cexp(ci*(pi2-chi(ic)))
	rrefs=cexp(-2*ci*chi(ic))
	refpc(ic)=rrefp
	refsc(ic)=rrefs
	chi(ic)=radinv*chi(ic)	!in degrees !!!
c	uu0(ic)=2*cosf*(1./cos2f)*sinchi
c	ww0(ic)=(1./cosf)*coschi
c Compute the horizontal and vertical components of displacement using the
C general equations and the reflection coefficients
	uu=one*cosf-cosf*rrefs+one*rrefp*sine
	uu0(ic)=cabs(uu)
	uphasec(ic)=radinv*atan2(aimag(uu),real(uu))
	sine1=sine**2-1
c	if(sine1.lt.0)sine1=0
	ww=sinf*one+sinf*rrefs-ci*sqrt(sine1)*rrefp
	ww0(ic)=cabs(ww)
	wphasec(ic)=radinv*atan2(aimag(ww),real(ww))
			end do
	ic=ic+1
	xc(ic)=90
	chi(ic)=90

21	format(i5,4f8.3)
	RETURN
	END
C-------------------------------------------------------------------------------
	subroutine axes
	dimension cchar(5),ind(5)
	COMMON /plot/ XL,XR,YB,YT,FC,NN,IC,px,ppy,delinv
	COMMON /VEL/ALBE,ALBE2,BEAL,BEAL2,RAD,RADINV
	CHARACTER*24 CNUM,cchar

	ind(1)=12
	cchar(1)=':0246::0720:'		!-pi
	ind(2)=24
	cchar(2)=':0246::0720::0517::0635:'	!-pi/2
	ind(3)=6
	cchar(3)=':0633:'			!0
	ind(4)=18
	cchar(4)=':0720::0517::0635:'	!pi/2
	ind(5)=6
	cchar(5)=':0720:'			!pi

	LINEWIDTH=1000
	CALL SETUSV('LW',LINEWIDTH)
	CALL LINE(XL,YB,XR,YB)
	CALL LINE(XL,YT,XR,YT)
	CALL LINE(XL,YB,XL,YT)
	CALL LINE(XR,YB,XR,YT)
	CALL PLCHHQ(PX,yb-.5,'Incidence angle',10.,0.,0.)
	CALL PLCHHQ(XL-17,PPY,'Absolute value',10.,90.,0.)
	CALL PLCHHQ(PX,yb-.5,'Incidence angle',10.,0.,0.)
	CALL PLCHHQ(radinv*fc,yb-.1,':734:',12.,0.,0.)

	do i=1,10
	iang=(i-1)*10
	write(cnum(1:2),'(i2)')iang
	ang=iang
	call line(ang,yb,ang,yb-.1)
	CALL PLCHHQ(ang,yb-.3,CNUM(1:2),10.,0,0)	
	end do	

	do i=1,11	!10
	amp=(i-1)*.5
	write(cnum(1:3),'(f3.1)')amp
	call line(xl,amp,xl-2,amp)
	CALL PLCHHQ(xl-8,amp,CNUM(1:3),10.,0.,0)	
	end do	

	CALL PLCHHQ(XR+10,PPY,'Phase :725:',10.,90.,0.)
	DO I=1,5
	IANG=-180+(I-1)*90	
	ANG=DELINV*(iang+190)
	CNUM(1:ind(i))=cchar(i)
	CALL PLCHHQ(XR+3,ANG,CNUM(1:ind(i)),10.,0,-1.)
	CALL LINE(XR,ANG,XR+2,ANG)
	END DO

	return
	end
C-------------------------------------------------------------------------------
	subroutine phamp(a,phase,amp)
	COMMON /VEL/ALBE,ALBE2,BEAL,BEAL2,RAD,RADINV
	complex a
	if(aimag(a).eq.0.and.real(a).eq.0)then
	phase=0
	else
	phase=radinv*atan2(aimag(a),real(a))
	end if
	amp=cabs(a)
	return
	end
